<template>
  <form class="d-input" :autocomplete="name === 'd-input' ? 'off' : 'on' ">
    <label v-if="isLabelVisible" :class="[hasErrors ? 'in-error' : '']" v-html="getTitle" />
    <vs-input
      v-model="value"
      v-validate="validate"
      :class="['w-full', classes]"
      :style="styles"
      :disabled="disabled"
      :placeholder="placeholder"
      :type="type"
      :name="name"
      :danger="hasErrors"
      :danger-text="errorMsg"
      @input="updateInput"
    />
  </form>
</template>

<script>
export default {
  props: {
    disabled: {
      required: false,
      type: Boolean,
      default: false
    },
    label: {
      required: false,
      type: String,
      default: "&nbsp"
    },
    placeholder: {
      required: false,
      type: String,
      default: ""
    },
    value: {
      required: false,
      type: [Object, String, Number],
      default: ""
    },
    type: {
      // text or number
      required: false,
      type: String,
      default: "text"
    },
    validate: {
      // use v-validation rules string
      required: false,
      type: String,
      default: ""
    },
    classes: {
      required: false,
      type: String,
      default: ""
    },
    showLabel: {
      // for cases when we don't need to have label tag at all
      required: false,
      type: Boolean,
      default: true
    },
    showLabelOnMobile: {
      // for cases when we don't need to have label tag at all on mobile
      required: false,
      type: Boolean,
      default: true
    },
    styles: {
      required: false,
      type: String,
      default: ""
    },
    name: {
      required: false,
      type: String,
      default: "d-input"
    },
    latinAndNumbersOnly: {
      required: false,
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      latinValidationError: false
    };
  },
  computed: {
    errorMsg() {
      if (this.latinValidationError) {
        return this.$t("generalTitles.latinError");
      } else {
        return this.errors.first(this.name);
      }
    },

    hasErrors() {
      return !!this.errors.first(this.name) || this.latinValidationError;
    },

    isLabelVisible() {
      if (this.isMobile) {
        return this.showLabelOnMobile;
      } else {
        return this.showLabel;
      }
    },

    isMobile() {
      return screen.width < 576;
    },

    getTitle() {
      let append = "";
      if (this.validate.indexOf("required") !== -1) {
        append = " *";
      }
      return `${this.label}${append}`;
    }
  },

  watch: {
    value(val) {
      if (this.latinAndNumbersOnly) {
        const latinValidation = /^[A-Za-z0-9]+$/;
        if (val !== null) {
          if (!val.match(latinValidation)) {
            this.latinValidationError = true;
          } else {
            this.latinValidationError = false;
          }
        }
      }
    }
  },

  methods: {
    updateInput() {
      this.$emit("input", this.value);
    }
  }
};
</script>

<style lang="scss">
@import "@/assets/scss/vuexy/_variables.scss";

.d-input {
  // .vs-input-primary .vs-input--input:focus {
  // 	border-color: $d-input-focus-color !important;
  // }
  label {
    font-size: $d-input-label-size;
    padding-left: $d-input-label-padding;
  }

  .in-error {
    color: red !important;
  }
}
</style>
